con
  {{
  Function plotter 1.0 by FilipS
  
  1: Requiements
        A propeller able to output to a TV. (See reqs. in the TV-driver's documentation)
          but I reccommend at least 80MHz, or the calculation will be slow. 
        A TV (Pins 12,13,14,15)
        A Keyboard (Pins 26,27)

        The pins may of course be changed if you modify the code. These pins
        are the ones used in the demoboard.
  
  2: Screens
        This program consist of 6 screens which I'm going to explain here.

        2.1: The main screen
              This screen consists of two crossing lines and four number-lables,
              they form a graph. This is where your plotting is done. If you see
              moving grey lines here sometime, don't worry, they're just telling
              that the program is drawing, it's not your TV.
              
              Arrow keys - Change the position of origo (where the lines
              are crossing each other.
         
              W,S,A,D - Change the scale, increasing/decreasing by 5 at each
              side of the screen.
         
              M - Open the menu-screen (see 1.2).
              
        2.2: The menu-screen
              This is where you go if you want to do something other than looking
              at your nice graphs. There are currently 3 items here. They take you
              to other screens.
         
              Left/right arrow - Select an item.
         
              Return - Open the selected screen. The items are named like the screens.
         
              Esc - Go back to the main screen (see 1.1).
         
        2.3: The New Formula-screen
              Go here if you want to enter a new formula to draw, it does not erase
              any of your other formulas.
         
              Left/Right arrow - Move cursor.
         
              F1..F3 - Select the color of the line. Watch the square in the left corner
              to see the selected color.
         
              Every other key - Type the formula.
         
              Return - Save formula and go back to the main screen. (see 1.1)
         
              Esc - Dischard formula and go back to the main screen.
         
        2.4: The Edit Formula-screen
              This is where you edit your formulas, it works like 1.3 except that you
              can step through your formulas by using up/down arrow and that you need
              to press return to apply the formula change. An arrow in the right corner
              tells you whenever the formula has been changed and not applied. You can
              also delete formulas here by pressing the Delete-key.
         
              Left/Right arrow - Move cursor.
         
              Up/Down arrow - Cycle through your formulas.
         
              Return - Apply changed formula.
         
              Esc - Go back to the main screen. (see 1.1)
              
              F1..F3 - Select the color of the line. Watch the square in the left corner
              to see the selected color.
         
              Every other key - Type the formula.
         
        2.5: The change colors-screen.
              This screen doesn't look much different to the menu screen, except that the
              arrows on the menu have dissapeared. This screen changes the palette that is
              used in the program.
         
              Left/Right arrow - Change color.
         
        2.6: The message-screen.
              This screen appears when something is wrong to tell you what it is. It's
              like the message-boxes in windows.
         
              Return - Close the message and go on.

  3: Formulas
        Here is what the parser is able to do right now.

        3.1: Operators
                + - Add
                - - Subtract
                * - Multiply
                / - Dividy
                ^ - Power of
        3.2: Functions
                SIN
                COS
                TAN
                ASIN - The inverse of SIN
                ACOS - The inverse of COS
                ATAN - The inverse of TAN
                RAD - Convert from degrees to radians
                DEG - Convert from radians to degrees
                SQR - Square of a number
        3.3: Constants
                PI, E
        3.4: Operator priority
                Lowest
                +,-
                *,/
                ^
                SIN, COS,TAN,ASIN,ACOS,ATAN,RAD,DEG,SQR
                Highest
                
        3.5: Known bugs
                When you type two operators with equal priority after each other the formula
                is processed backwards, 2*3/4 is processed like 2*(3/4) instead of (2*3)/4.
                Of course parantheses solve this issue, just remember to put them out!

        3.6: Error messages
                Formula too complex - The stack size needed to compute the equation is too big,
                  try to simplify it by pre-calculate some terms for example.

                Missing parameter - There isn't enough parameters to invoke some of the instructions
                in your formula. Double check it.
                
                Missing '(' - Self explanatory?

                Missing ')' - Self explanatory?

                Too many parameters - There was more than one number in the stack at the end, you've
                  specified too many parameters (or missed something).      

  }}
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000

  pn = 1  ''PN = Pal/Ntsc 1 for pal, 0 for Ntsc

  Bitmapp = $67C0'7400
  DBuff = $4FC0 '6800

  'ownbase = dbuff - 800 '800 bytes att lagra egna banor p!

  XTiles = 12'8
  YTiles = 8'4
  xpix = xtiles * 16 - 1
  ypix = ytiles * 16 - 1
  paramcount = 14

  Aleft = $C0
  Aright = $C1
  Aup = $C2
  Adown = $C3
  ESC = $CB
  KRet = $0D

  Max_Formulas = 10
  Formula_len = 50

var
  long  tv_status     '0/1/2 = off/visible/invisible           read-only
  long  tv_enable     '0/? = off/on                            write-only
  long  tv_pins       '%ppmmm = pins                           write-only
  long  tv_mode       '%ccinp = chroma,interlace,ntsc/pal,swap write-only
  long  tv_screen     'pointer to screen (words)               write-only
  long  tv_colors     'pointer to colors (longs)               write-only               
  long  tv_hc         'horizontal cells                        write-only
  long  tv_vc         'vertical cells                          write-only
  long  tv_hx         'horizontal cell expansion               write-only
  long  tv_vx         'vertical cell expansion                 write-only
  long  tv_ho         'horizontal offset                       write-only
  long  tv_vo         'vertical offset                         write-only
  long  tv_broadcast  'broadcast frequency (Hz)                write-only
  long  tv_auralcog   'aural fm cog                            write-only

  word  screen[xtiles * ytiles]
  long  colors[5]           '1=BG, 2=palett1, 3=palett2 (anvnds fr att indikera att arbete pgr)

  byte waitst
  byte curr_pal

  long GridTop, GridBottom, GridLeft, GridRight

  'byte textheight, textwidth
  byte tb_ptr, tb_maxlen, tb_current, tb_mode '0=normal, 1=Vlj frg, 2=Vlj formel + frg
  word tb_str
  byte tb_changed, tb_tstr[formula_len]

  byte status
  byte menu

  byte formulas[max_formulas * (formula_len + 1)]
  long lastval[max_formulas]

  byte errdata

  'Data fr meddelanderuta
  word msg_text
  byte msg_on
obj
  tv : "TV"
  gr : "Graphics"
  kb : "Keyboard"
  nrs : "Simple_Numbers"
  parser : "Parser"

pub main | tx, ty, fd
   longmove(@tv_status, @tvparams, paramcount)
   tv_screen := @screen
   tv_colors := @colors

   tv.start(@tv_status)

   repeat tx from 0 to xtiles - 1
    repeat ty from 0 to ytiles - 1 
      'screen[(ty - 1) * xtiles + tx] := (@bitmapp) >> 6 + tx * ytiles + ty + (1 << 10)
      screen[ty * xtiles + tx] := (bitmapp ) >> 6 + tx * ytiles + ty + ((1 + tx & 3) << 10)
  colors[0] := palette[0] 
  curr_pal := 0
  StopWait  
  gr.start
  gr.setup(xtiles,ytiles,0,0,dbuff)
  gr.clear
  kb.start(26,27)

  GridBottom := -10
  GridTop := 10
  GridLeft := -10
  GridRight := 10
  status := 0

  DrawGrid
  gr.copy(bitmapp)
  parser.start(@errdata)
  msg_on := 0
  repeat tx from 0 to max_formulas - 1
    formulas[tx * (formula_len + 1)] := 0
  fd := -1
  repeat
    tx := kb.key
    if (fd == 0)
      ty := cnt
    if ((fd > -1) & (status == 0))
      if (ty + clkfreq / 10 < cnt)
        DoWait
        ty := cnt
      DrawFormulas(fd++)
      gr.copy(bitmapp)      
      if (fd == xpix)
        fd := -1
        StopWait
    else
      StopWait
    if (tx > 0)
      case (KeyHandler(tx))
        1: 'Rita om allt!
          gr.clear
          DrawGrid
          fd := 0
          'Rita linjer ox!
          gr.copy(bitmapp)
        2: 'Rita om menyn
          drawmenu
          gr.copy(bitmapp)
        3:
          drawtb
          gr.copy(bitmapp)
      if (msg_on == 1)
        drawmsg
        gr.copy(bitmapp) 
        

pri KeyHandler(key): upd |t
  if (msg_on == 1)
    return msghandler(key)
  elseif (status == 0) 'Flytta bilden, pilarna = flytta origo, asdw = skala
    case (key)
      $C0: 'Vnsterpil
        GridLeft += 5
        GridRight += 5
        return 1
      $C1: 'Hgerpil
        GridLeft -= 5
        GridRight -= 5
        return 1
      $C2: 'Uppil
        GridTop -= 5
        GridBottom -= 5
        return 1
      $C3: 'Nertpil
        GridTop += 5
        GridBottom += 5
        return 1
      "a","A":
        GridLeft += 5
        GridRight -= 5
        if (GridLeft => GridRight)
          GridLeft -= 5
          GridRight += 5  
        return 1
      "d","D":
        GridLeft -= 5
        GridRight += 5
        return 1
      "w","W": 'Uppil
        GridTop += 5
        GridBottom -= 5
        return 1
      "s","S": 'Nertpil
        GridTop -= 5
        GridBottom += 5
        if (GridBottom => GridTop)
          GridTop += 5
          GridBottom -= 5  
        return 1
      "m","M": 'Meny
        status := 1
        menu := 0
        return 2
  elseif (status == 1)
    case (key)
      $CB: 'esc
        status := 0
        return 1
      $C1: 'hgerpil
        if (++menu == menucaps)
          menu := 0
        return 2
      $C0: 'vnsterpil
        if (menu == 0)
          menu := menucaps - 1
        else
          menu--
        return 2
      $0D: 'return
        'Kr menysaken!
        case (menu)
          0:
            repeat t from 0 to max_formulas
              if formulas[t * (formula_len + 1)] == 0
                status := 3
                tb_ptr := 0
                tb_maxlen := formula_len
                tb_str := @formulas[(formula_len + 1) * t + 1]
                byte[tb_str - 1] := 1
                bytefill(@tb_tstr, 0, formula_len)
                tb_mode := 1
                return 3
            ShowMSG(string("Out of memory!"))
          1:
            repeat t from 0 to max_formulas
              if formulas[t * (formula_len + 1)] <> 0
                status := 3
                tb_changed := 0
                tb_ptr := 0
                tb_maxlen := formula_len
                tb_str := @formulas[(formula_len + 1) * t + 1]
                bytemove(@tb_tstr, tb_str, formula_len)
                tb_mode := 2
                tb_current := t
                return 3
            showmsg(string("No formulas!"))
          2:
            status := 2
            return 2
  elseif (status == 2) 'byt menyfrg
    case (key)
      Aright:
        if (++curr_pal == num_palettes)
          curr_pal := 0
        StopWait
      Aleft:
        if (curr_pal == 0)
          curr_pal := num_palettes - 1
        else
          curr_pal--
        StopWait
      ESC,KRet:
        status := 1
        return 2
  elseif (status == 3)
    upd := TBHandler(key)
    case upd
      -1:
        if (tb_mode <> 0)
          if (tb_tstr == 0)
            byte[tb_str - 1] := 0
            status := 0            
            return 1
          parser.Calculate(@tb_tstr,0)
          if (errdata == 0)
            bytemove(tb_str, @tb_tstr, formula_len)
          else
            'byte[tb_str - 1] := 0
            ShowMSG(@@errors[errdata - 1])
            return 3
        status := 0
        return 1
      -2:
        if (tb_mode <> 0)
          byte[tb_str - 1] := 0
          status := 0
          return 1 
      other:
        return upd 
    
pri TBHandler(key):r |t
  case (key)
    ALeft:
      if (tb_ptr > 0)
        tb_ptr--
        return 3
    ARight:
      if (tb_ptr < strsize(@tb_tstr))
        tb_ptr++
        return 3
    KRet:
      if (tb_mode == 2)
        
        parser.Calculate(@tb_tstr,0)
        if (errdata == 0)
          bytemove(tb_str, @tb_tstr, formula_len)
          tb_changed := 0
          return 3
        else
          'byte[tb_str - 1] := 0
          ShowMSG(@@errors[errdata - 1])
          return 3
      else
        return -1
    $D0..$D2:
      byte[tb_str - 1] := key - $CF
      return 3
    ADown:
      if (tb_mode == 2)
        t := tb_current
        repeat
          if (++t => max_formulas)
            t := 0
          if (t == tb_current)
            showMsg(string("No more formulas!"))
            return 0 
          if (formulas[(formula_len + 1) * t] <> 0)
            'bytemove(tb_str, @tb_tstr, formula_len)
            tb_ptr := 0
            tb_changed := 0
            tb_current := t
            tb_str := @formulas[(formula_len + 1) * t + 1]
            bytemove(@tb_tstr, tb_str, formula_len)
            return 3
    AUp:
      if (tb_mode == 2)
        t := tb_current
        repeat
          if (t > 0)
            t--
          else
            t := max_formulas - 1
          if (t == tb_current)
            showMsg(string("No more formulas!"))
            return 0 
          if (formulas[(formula_len + 1) * t] <> 0)
            tb_ptr := 0
            tb_changed := 0
            tb_current := t
            tb_str := @formulas[(formula_len + 1) * t + 1]
            bytemove(@tb_tstr, tb_str, formula_len)
            return 3
    $C9: 'DEL
      if (tb_mode == 2)
        byte[tb_str - 1] := 0
        t := tb_current
        repeat
          if (++t => max_formulas)
            t := 0
          if (t == tb_current)
            showMsg(string("No formulas!"))
            status := 0
            return 1 
          if (formulas[(formula_len + 1) * t] <> 0)
            'bytemove(tb_str, @tb_tstr, formula_len)
            tb_changed := 0
            tb_ptr := 0
            tb_current := t
            tb_str := @formulas[(formula_len + 1) * t + 1]
            bytemove(@tb_tstr, tb_str, formula_len)
            return 3
    $C8: 'BSP
      if (tb_str > 0)
        RemStr(@tb_tstr, tb_ptr--)
        return 3
    esc:
      if (tb_mode == 2)
        status := 0
        return 1
      return -2
    other:
      if (strsize(@tb_tstr) <  tb_maxlen)
        InsertStr(@tb_tstr, key, tb_ptr++)
        tb_changed := 1
        return 3
  return 0             
pri ShowMSG(text)
  msg_text := text
  msg_on := 1
pri MsgHandler(k)
  if (k == 13)
    msg_on := 0
    if (status == 3)
      gr.clear
      DrawGrid
      DrawMenu
      return 3
    elseif (status == 1)
      gr.clear
      DrawGrid
      return 2
    return 1
  return 0

pri DrawMSG
  gr.color(2)
  gr.box(0, ypix / 2 - 5, xpix, 25)
  gr.textmode(1,1,6,%0100)
  gr.color(1)
  gr.text(xpix / 2, ypix / 2, msg_text)
  gr.textmode(1,1,6,0)
  gr.pix(0,ypix / 2,0,@msg_icon)
  gr.pix(xpix - 16, ypix / 2, 0, @msg_ret_icon)

dat
errors  word  @err1, @err2, @err3, @err4, @err5
err1    byte  "Error: Formula too complex",0
err2    byte  "Error: Missing parameter",0
err3    byte  "Error: Missing '('",0
err4    byte  "Error: Missing ')'",0
err5    byte  "Error: Too many parameters",0

msg_icon      word
              byte 2,15,0,0
              word %%00000003, %%30000000
              word %%00000003, %%30000000
              word %%00000030, %%03000000
              word %%00000030, %%03000000
              word %%00000301, %%10300000
              word %%00000301, %%10300000
              word %%00003001, %%10030000
              word %%00003001, %%10030000
              word %%00030001, %%10003000
              word %%00030001, %%10003000
              word %%00300001, %%10000300
              word %%00300000, %%00000300
              word %%03000001, %%10000030
              word %%03000001, %%10000030
              word %%33333333, %%33333333

msg_ret_icon  word
              byte 2,15,0,0
              word %%00000000, %%03300000
              word %%00000000, %%03300000
              word %%00000000, %%03300000
              word %%00000000, %%03300000
              word %%00000000, %%03300000
              word %%00000000, %%03300000
              word %%00000000, %%03300000
              word %%00030000, %%03300000
              word %%00330000, %%03300000
              word %%03330000, %%03300000
              word %%33333333, %%33300000
              word %%33333333, %%33300000
              word %%03330000, %%00000000
              word %%00330000, %%00000000
              word %%00030000, %%00000000
          
pri DrawTB|a
  a := 0
  gr.color(2)
  gr.box(0,ypix - 15,xpix, 16)

  if (tb_mode => 1)
    gr.color(byte[tb_str - 1])
    gr.box(a+2,ypix - 13, 10,10)
    gr.color(0)
    gr.plot(a+2,ypix - 13)
    gr.line(a+12,ypix - 13)
    gr.line(a+12,ypix - 3)
    gr.line(a+2,ypix - 3)
    gr.line(a+2,ypix - 13)
    a += 15
  if (tb_mode => 2)
    gr.color(0)
    gr.plot(a + 3,ypix - 5)
    gr.line(a + 7, ypix - 1)
    gr.line(a + 11, ypix - 5)
    gr.plot(a + 3, ypix - 10)
    gr.line(a + 7, ypix - 14)
    gr.line(a + 11, ypix - 10)
    a += 15
    if (tb_changed == 1)
      gr.pix(xpix - 16, ypix - 15, 0, @msg_ret_icon)
      
    
  gr.color(1)
  gr.text(a,ypix - 15, @tb_tstr)
  gr.plot(tb_ptr * 6 + a, ypix - 15)
  gr.line(tb_ptr * 6 + a, ypix)
              
pri DrawMenu |t,a
  gr.color(2)
  gr.box(0,0,xpix / 2, 15)
  gr.color(1)
  if (status == 1)
    gr.text(0,0,string("<"))
  a := @menucaps + 1
  t := menu
  repeat until t == 0
    a += strsize(a) + 1
    t--
  gr.text(12,0,a)
  if (status == 1)
    gr.text(xpix / 2 - 6, 0, string(">"))    
pri DrawFormulas(x)|xv, f
  repeat f from 0 to max_formulas - 1
    if (formulas[f * (formula_len + 1)] > 0)
      
      xv := parser.IntToFloat(x)
      xv := parser.FloatMul(xv, parser.FloatDiv(parser.IntToFloat(GridRight - GridLeft),parser.IntToFloat(xpix)))  'xv = xv * ((GridRight - GridLeft) / xpix)
      xv := parser.FloatAdd(xv, parser.IntToFloat(GridLeft)) 'xv += GridLeft
      xv := parser.Calculate(@formulas[f * (formula_len + 1) + 1], xv)
      'Konvertera till pixlar och rita!      
      xv := parser.FloatSub(xv, parser.IntToFloat(GridBottom))
      xv := parser.FloatDiv(xv, parser.FloatDiv(parser.IntToFloat(GridTop - GridBottom),parser.IntToFloat(ypix)))
      gr.color(formulas[f * (formula_len + 1)])
      xv := parser.FloatTrunc(xv)
      if ((xv < 0) | (xv > ypix))
        xv := -1
      if (xv > -1)
        if ((x > 0) & (lastval[f] > -1))
          gr.plot(x-1,lastval[f])
          gr.line(x,xv)
        else
          gr.plot(x,xv)
      lastval[f] := xv
              
pri DrawGrid | vline, hline, de, t
  if ((gridleft < 0) & (gridright > 0))
    vline := GridRight - GridLeft
    vline := (xpix * ||GridLeft) / vline
  elseif (gridleft => 0)
    vline := 0
  else
    vline := xpix

  gr.color(1)
  gr.plot(vline, 0)
  gr.line(vline, ypix)  
  if (vline + 30 > xpix)
    gr.textmode(1,1,6,%1000)
    gr.text(vline - 2, 0, nrs.dec(GridBottom))
    gr.finish
    gr.text(vline - 2, ypix - 15, nrs.dec(GridTop))
    gr.textmode(1,1,6,%0000)
  else
    gr.text(vline + 2, 0, nrs.dec(GridBottom))
    gr.finish
    gr.text(vline + 2, ypix - 15, nrs.dec(GridTop))

  if ((gridbottom < 0) & (gridtop > 0))
    hline := GridTop - GridBottom
    hline := (ypix * ||GridBottom) / hline
  elseif (gridbottom => 0)
    hline := 0
  else
    hline := ypix
    
  gr.plot(0,hline)
  gr.line(xpix, hline)
  if (hline - 15 < 0)
    gr.text(0, hline, nrs.dec(GridLeft))
    gr.textmode(1,1,6,%1000)
    gr.text(xpix, hline, nrs.dec(GridRight))
  else
    gr.text(0, hline - 15, nrs.dec(GridLeft))
    gr.textmode(1,1,6,%1000)
    gr.text(xpix - 2, hline - 15, nrs.dec(GridRight))

  gr.textmode(1,1,6,%0)    
pri DoWait
  if (waitst == 0)
    colors[4] := palette[curr_pal * 2 + 1]
  else
    colors[waitst] := palette[curr_pal * 2 + 1]
  colors[waitst + 1] := palette[curr_pal * 2 + 2]
  waitst++
  if (waitst > 3)
    waitst := 0    
pri StopWait
  colors[4] := colors[3] := colors[2] := colors[1] := palette[curr_pal * 2 + 1]
  waitst := 0

pri RemStr(strptr,pos)|i,s
  s := strsize(strptr)
  i := pos - 2
  repeat until i => s
    i++
    byte[strptr + i] := byte[strptr + i + 1]   
  byte[strptr + s] := 0      
pri InsertStr(strptr,char,pos)|i,a,s
  s := strsize(strptr)
  'if pos == s
  '  byte[strptr + pos] := char
  '  return
  i := s
  repeat until i =< pos
     i-- 
    a := strptr + i
    byte[a + 1] := byte[a]

  byte[strptr + pos] := char
dat
menucaps      byte 3,"New formula",0,"Edit formula",0,"Change colors",0
num_palettes byte 2
palette long $BB_1B_6C_04 'BG
        long $0B_BC_07_02 'Light White-Red-Blue
        long $0A_BB_06_03 'Dark
        long $BB_6C_1B_02 'Light, Blue-Green-Red
        long $BA_6A_1B_03 'Dark

        

tvparams                long    0               'status
                        long    1               'enable
                        long    %001_0101       'pins
                        long    %0000           'mode
                        long    0               'screen
                        long    0               'colors
                        long    xtiles         'hc
                        long    ytiles         'vc
                        long    10              'hx
                        long    1               'vx
                        long    0               'ho
                        long    0               'vo
                        long    60_000_000      'broadcast
                        long    0               'auralcog  